# Rougail

Rougail est un bibliothèque python3 qui permet de charger des dictionnaires (fichiers au format XML), de charger les variables dans Tiramisu et de générer des templates.

## La bibliothèque

  - [Utiliser la bibliothèque](dev/README.md)
  - [Personnaliser la configration de la bibliothèque](dev/config.md)

## Les dictionnaires

Un dictionnaire est un fichier XML donc la structure est expliqué ci-dessous.

Un dictionnaire contient en ensemble de variable, utilisable à tout moment, notamment dans des templates.

Il est possible d'avoir plusieurs espace de nom pour classer les variables (appeler aussi "extra") mais il est aussi possible, à l'interieur de ce espace de nom de mettre des familles pour classer les variables.

Les familles et les variables peuvent être défini dans plusieurs dictionnaires. Ces dictionnaires s'aggrège alors. Il est possible de rajouter des familles des variables, des services, des éléments à un service et des contraintes.

Il est également possible de redéfinir des éléments pour changer les comportement d'une variable ou d'un service.

FIXME expliquer les noms des variables dans les extras

### Les variables

  - [Les familles](family/README.md)
  - [Les variables](variable/README.md)

### Les services

  - [La gestion d'un fichier](service/file.md)
  - [La gestion d'un fichier de service systemd](service/override.md)
  - [La gestion d'un port](service/port.md)
  - [La gestion d'une ip](service/ip.md)

### Les contraintes

  - [Les calcules automatiques](fill/README.md)
  - [Les vérifications des valeurs](check/README.md)
  - [Les conditions](condition/README.md)
  - [Les variables meneuses ou suiveuses](variable/leadership.md)

## Les templates

  - Type creole


FIXME :
- une variable avec nom unique sauf pour extra
